package gui.run;


public abstract class RunCheckBoxMenuItem extends
        javax.swing.JCheckBoxMenuItem 
        implements java.awt.event.ItemListener, Runnable {
    public RunCheckBoxMenuItem(String label) {
        this(label,false);
    }

    public RunCheckBoxMenuItem(String s, boolean b) {
        super(s, b);
        addItemListener(this);
        ShortcutUtils.addShortcut(this);
    }

    public RunCheckBoxMenuItem(javax.swing.Icon i) {
        super(i);
        addItemListener(this);
    }

    public RunCheckBoxMenuItem() {
        addItemListener(this);
    }

    public void itemStateChanged(java.awt.event.ItemEvent e) {
        run();
    }

    public static void main(String args[]) {
        gui.ClosableJFrame cf = new gui.ClosableJFrame("RunRadio");
        java.awt.Container c = cf.getContentPane();

        javax.swing.JMenuBar mb = new javax.swing.JMenuBar();
        RunMenu m = new RunMenu("[Checkable");
        m.add(new RunCheckBoxMenuItem("Check[1{alt shift 1}") {
            public void run() {
                System.out.println(getText());
            }
        });
        m.add(new RunCheckBoxMenuItem("Check[2{alt shift 2}") {
            public void run() {
                System.out.println(getText());
            }
        });

        mb.add(m);
        cf.setJMenuBar(mb);

        c.setLayout(new java.awt.GridLayout(1, 0));
        cf.setSize(200, 200);
        cf.setVisible(true);
    }
}